/* 
 * © 2008-2009 Sun Microsystems, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LF_SELECTOR_H_
#define _LF_SELECTOR_H_

#include "mforms/selector.h"

#include "lf_view.h"

namespace mforms
{
namespace gtk
{

class SelectorImpl : public ViewImpl
{
 public:
  class Impl;

 private:
  virtual Gtk::Widget *get_outer() const;
  virtual Gtk::Widget *get_inner() const;

  Gtk::Alignment                    *_align;
  Impl                              *_pimpl;

 protected:
  SelectorImpl(::mforms::Selector *self, ::mforms::SelectorStyle style);
  static void callback(::mforms::Selector *self);
  static bool create(::mforms::Selector *self, ::mforms::SelectorStyle style);
  static void clear(::mforms::Selector *self);
  static int add_item(::mforms::Selector *self, const std::string &item);
  static void add_items(::mforms::Selector *self, const std::list<std::string> &items);
  static std::string get_item(::mforms::Selector *self, int index);
  static std::string get_text(::mforms::Selector *self);
  static void set_index(::mforms::Selector *self, int index);
  static int get_index(::mforms::Selector *self);
  static int get_item_count(::mforms::Selector *self);
  static void set_value(::mforms::Selector *self, const std::string& value);

 public:
  ~SelectorImpl();
  static void init();
};

}
}


#endif
