/* 
 * © 2008-2009 Sun Microsystems, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LFI_CONTAINER_H_
#define _LFI_CONTAINER_H_

#include "lf_view.h"

namespace mforms { namespace gtk
{  
  class ContainerImpl : public ViewImpl
  {
  protected:
    ContainerImpl(::mforms::View *self)
      : ViewImpl(self)
    {
    }

    void add(::mforms::View *child)
    {
      ((Gtk::Container*)get_inner())->add(*child->get_data<ViewImpl>()->get_outer());
      child->show();
    }

    void remove()
    {
      ((Gtk::Bin*)get_inner())->remove();
    }

    void remove(::mforms::View *child)
    {
      ((Gtk::Container*)get_inner())->remove(*child->get_data<ViewImpl>()->get_outer());
    }
  };
  
}; };

#endif /* _LFI_CONTAINER_H_ */
