/* 
 * Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, 
 * Boston, MA 02110-1301  USA
 */
#ifndef _MFORMS_IMAGEBOX_H_
#define _MFORMS_IMAGEBOX_H_

#include <mforms/base.h>
#include <mforms/view.h>


namespace mforms 
{
  class ImageBox;

#ifndef DOXYGEN_SHOULD_SKIP_THIS
#ifndef SWIG
  struct ImageBoxImplPtrs
  {
    bool (__stdcall *create)(ImageBox *);
    void (__stdcall *set_image)(ImageBox *, const std::string&);
  };
#endif
#endif

  /** Shows an image file. */
  class MFORMS_EXPORT ImageBox : public View
  {
  public:
    ImageBox();
    
    /** Sets the path to the image file. 
     
     Image formats accepted depend on platform, but usually png and jpeg will work. */
    void set_image(const std::string &file);

  protected:
    ImageBoxImplPtrs *_imagebox_impl;
  };
};

#endif
