/* 
 * © 2007-2008 MySQL AB, 2008-2009 Sun Microsystems, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _GRTPP_MODULE_LUA_H_
#define _GRTPP_MODULE_LUA_H_

#include "grtpp.h"

#include "lua_context.h"

namespace grt {

  class LuaModuleLoader;
  
  class MYSQLGRT_PUBLIC LuaModule : public Module
  {
    friend class LuaModuleLoader;
  public:
    LuaModule(LuaModuleLoader *loader);
    virtual ~LuaModule();

  protected:

  };


  class MYSQLGRT_PUBLIC LuaModuleLoader : public ModuleLoader
  {
  public:
    LuaModuleLoader(GRT *grt);
    virtual ~LuaModuleLoader();
    
    virtual std::string get_loader_name() { return LanguageLua; }
    
    virtual Module *init_module(const std::string &path);

    virtual void refresh();
    
    virtual bool load_library(const std::string &file);

    LuaContext *get_lua_context() { return &_lua; }
    
    virtual bool check_file_extension(const std::string &path);
    virtual bool run_script_file(const std::string &path);
    
  protected:
    friend class LuaModule;

    LuaContext _lua;


    ValueRef call_function(const BaseListRef &args, LuaModule *module, const Module::Function &function);
  };

  
};

#endif
